Loading...
Searching...
No Matches
Ogre::DistanceLodBoxStrategy Class Reference
Core » Level of Detail

Level of detail strategy based on distance from camera to an object's bounding box. More...

`#include <OgreDistanceLodStrategy.h>`

Inheritance diagram for Ogre::DistanceLodBoxStrategy:
[legend]

## Public Member Functions

| DistanceLodBoxStrategy ()
| Default constructor.
Real | getSquaredDepth (const MovableObject *movableObject, const Ogre::Camera *camera) const override
| Get the squared distance between the camera and the LOD object.
Public Member Functions inherited from Ogre::DistanceLodStrategyBase
| DistanceLodStrategyBase (const String &name)
| Default constructor.
Real | getBaseValue () const override
| Get the value of the first (highest) level of detail.
ushort | getIndex (Real value, const Material::LodValueList &materialLodValueList) const override
| Get the index of the LOD usage which applies to a given value.
ushort | getIndex (Real value, const Mesh::MeshLodUsageList &meshLodUsageList) const override
| Get the index of the LOD usage which applies to a given value.
bool | isReferenceViewEnabled () const
| Determine if use of the reference view is enabled.
bool | isSorted (const Mesh::LodValueList &values) const override
| Determine if the LOD values are sorted from greatest detail to least detail.
void | setReferenceView (Real viewportWidth, Real viewportHeight, Radian fovY)
| Sets the reference view upon which the distances were based.
void | setReferenceViewEnabled (bool value)
| Enables to disables use of the reference view.
void | sort (Mesh::MeshLodUsageList &meshLodUsageList) const override
| Sort mesh LOD usage list from greatest to least detail.
Real | transformBias (Real factor) const override
| Transform LOD bias so it only needs to be multiplied by the LOD value.
Real | transformUserValue (Real userValue) const override
| Transform user supplied value to internal value.
Public Member Functions inherited from Ogre::LodStrategy
| LodStrategy (const String &name)
| Constructor accepting name.
virtual | ~LodStrategy ()
| Virtual destructor.
void | assertSorted (const Mesh::LodValueList &values) const
| Assert that the LOD values are sorted from greatest detail to least detail.
const String & | getName () const
| Get the name of this strategy.
Real | getValue (const MovableObject *movableObject, const Camera *camera) const
| Compute the LOD value for a given movable object relative to a given camera.
Public Member Functions inherited from Ogre::Singleton< DistanceLodBoxStrategy >
| ~Singleton (void)

## Static Public Member Functions

static DistanceLodBoxStrategy & | getSingleton (void)
| Get the singleton instance.
static DistanceLodBoxStrategy * | getSingletonPtr (void)
| Get the singleton instance.
Static Public Member Functions inherited from Ogre::Singleton< DistanceLodBoxStrategy >
static DistanceLodBoxStrategy & | getSingleton (void)
| Get the singleton instance.
static DistanceLodBoxStrategy * | getSingletonPtr (void)
| Get the singleton instance.

## Detailed Description

Level of detail strategy based on distance from camera to an object's bounding box.

The purpose of the reference view is to ensure a consistent experience for all users. Monitors of different resolutions and aspect ratios will each have different results for the distance queries.

  It depends on gameplay testing. If all testers had 16:9 monitors and 110° FOV, then that's the value you should enter (to ensure as much as possible the experience stays consistent for all other users who don't have a 16:9 monitor and/or use a different FOV).

  If all your testers had 4:3 monitors, then enter a 4:3 resolution.

  If all your testers had varying resolutions or you just didn't care, then this feature is useless for you and should be disabled (default: disabled).

## Constructor & Destructor Documentation

## DistanceLodBoxStrategy()

Ogre::DistanceLodBoxStrategy::DistanceLodBoxStrategy | ( |  | ) |

Default constructor.

Referenced by getSingleton(), and getSingletonPtr().

## Member Function Documentation

## getSquaredDepth()

Real Ogre::DistanceLodBoxStrategy::getSquaredDepth | ( | const MovableObject * | movableObject,
|  | const Ogre::Camera * | camera ) const

override virtual

Get the squared distance between the camera and the LOD object.

Implements Ogre::DistanceLodStrategyBase.

## getSingleton()

DistanceLodBoxStrategy & Ogre::DistanceLodBoxStrategy::getSingleton | ( | void |  | ) |

static

Get the singleton instance.

References DistanceLodBoxStrategy().

## getSingletonPtr()

DistanceLodBoxStrategy * Ogre::DistanceLodBoxStrategy::getSingletonPtr | ( | void |  | ) |

static

Get the singleton instance.

References DistanceLodBoxStrategy().

Referenced by Ogre::LodConfig::LodConfig().

The documentation for this class was generated from the following file:

- OgreDistanceLodStrategy.h